"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ChartApp = void 0;
var components = _interopRequireWildcard(require("echarts/components"));
var charts = _interopRequireWildcard(require("echarts/charts"));
var echarts = _interopRequireWildcard(require("echarts/core"));
var _SVGRenderer = require("./SVGRenderer");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
const ChartApp = {
  use: ext => {
    echarts.use(ext);
  },
  setup: function () {
    let ext = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    ChartApp.use([_SVGRenderer.SVGRenderer, components.TitleComponent, components.TooltipComponent, components.GridComponent, components.LegendComponent, components.MarkLineComponent, components.MarkPointComponent, ...ext]);
  },
  setupAll: () => {
    ChartApp.use([_SVGRenderer.SVGRenderer, ...Object.values(components), ...Object.values(charts)]);
  }
};
exports.ChartApp = ChartApp;
//# sourceMappingURL=chartApp.js.map