import { getInstance } from 'zrender/lib/zrender';
const noop = () => {};
export function dispatchEventsToZRender(zrenderId, types, nativeEvent) {
  let eventArgs = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {
    zrX: nativeEvent.locationX || nativeEvent.x,
    zrY: nativeEvent.locationY || nativeEvent.y
  };
  if (zrenderId) {
    var _getInstance;
    var handler = (_getInstance = getInstance(zrenderId)) === null || _getInstance === void 0 ? void 0 : _getInstance.handler;
    if (handler) {
      types.forEach(function (type) {
        handler.dispatch(type, {
          preventDefault: noop,
          stopImmediatePropagation: noop,
          stopPropagation: noop,
          ...eventArgs
        });
      });
    }
  }
}
//# sourceMappingURL=events.js.map