export function throttle(func, wait) {
  let lastExecution = 0;
  return function () {
    const now = Date.now();
    if (now - lastExecution >= wait) {
      lastExecution = now;
      func(...arguments);
    }
  };
}
//# sourceMappingURL=throttle.js.map